unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ShellAPI, ExtCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Image1: TImage;
    Label10: TLabel;
    Label11: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label1: TLabel;
    Label2: TLabel;
    ComboBox2: TComboBox;
    Label3: TLabel;
    ComboBox1: TComboBox;
    Shape1: TShape;
    procedure Label11Click(Sender: TObject);
    procedure ComboBox1DrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure FormCreate(Sender: TObject);
    procedure ComboBox2DrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Label11Click(Sender: TObject);
begin
  ShellExecute(0,'Open', 'explorer', 'http://dev-zone.com/faqs/delphi/fqdph_index.php', nil, SW_SHOW);
end;

procedure TForm1.ComboBox1DrawItem(Control: TWinControl; Index:
Integer; Rect: TRect; State: TOwnerDrawState);
var
  Space: byte;
begin
  with Combobox1.canvas do
    begin
      FillRect(Rect);
      InflateRect(Rect,-1,-1);
      FillRect(Rect);
      if combobox1.Items.Strings[Index][1]='0' then
        // Ici on dcale les dpartements vers la droite.
        Space := 8
      else
        begin
          // Ici on dcale les rgions vers la droite.
          Space := 2;
          Font.style := [fsBold];
        end;
       TextOut(Rect.Left + Space, Rect.Top + 2, Copy(combobox1.Items.Strings[Index], 2, Length(Combobox1.Items.Strings[Index])-1));
    end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  // 1 - Reprsente les rgions.
  // 0 - Reprsente les dpartements.
  // Ce chiffre qui prcde les items servira d'identifiant.
  Combobox1.Items.Text := '1Alsace' +#13+
                          '0(67) Bas Rhin' +#13+
                          '0(68) Haut Rhin' +#13+
                          '1Aquitaine' +#13+
                          '0(24) Dordogne' +#13+
                          '0(33) Gironde' +#13+
                          '0(40) Landes' +#13+
                          '0(47) Lot et Garonne' +#13+
                          '0(64) Pyrnes Atlantiques' +#13+
                          '1Auvergne' +#13+
                          '0(03) Allier' +#13+
                          '0(15) Cantal' +#13+
                          '0(43) Haute Loire' +#13+
                          '0(63) Puy de Dme' +#13+
                          '1Basse Normandie' +#13+
                          '0(14) Calvados' +#13+
                          '0(50) Manche' +#13+
                          '0(61) Orne' +#13+
                          '1Bourgogne' +#13+
                          '0(21) Cte d''Or' +#13+
                          '0(58) Nivre' +#13+
                          '0(71) Sane et Loire' +#13+
                          '0(89) Yonne' +#13+
                          '1Bretagne' +#13+
                          '0(22) Ctes d''Armor' +#13+
                          '0(29) Finistre' +#13+
                          '0(35) Ille et Vilaine' +#13+
                          '0(56) Morbihan' +#13+
                          '1Centre' +#13+
                          '0(18) Cher' +#13+
                          '0(28) Eure et Loir' +#13+
                          '0(36) Indre' +#13+
                          '0(37) Indre et Loire' +#13+
                          '0(41) Loir et Cher' +#13+
                          '0(45) Loiret' +#13+
                          '1Champagne Ardenne' +#13+
                          '0(08) Ardennes' +#13+
                          '0(10) Aube' +#13+
                          '0(51) Marne' +#13+
                          '0(52) Haute Marne' +#13+
                          '1Corse' +#13+
                          '0(2A) Corse du Sud' +#13+
                          '0(2B) Haute Corse' +#13+
                          '1Dpartements d''Outre Mer' +#13+
                          '0(971) Guadeloupe' +#13+
                          '0(972) Martinique' +#13+
                          '0(973) Guyane' +#13+
                          '0(974) La Runion' +#13+
                          '0(975) Saint Pierre et Miquelon' +#13+
                          '0(976) Mayotte' +#13+
                          '1Franche Comt' +#13+
                          '0(25) Doubs' +#13+
                          '0(39) Jura' +#13+
                          '0(70) Haute Sane' +#13+
                          '0(90) Territoire de Belfort' +#13+
                          '1Haute Normandie' +#13+
                          '0(27) Eure' +#13+
                          '0(76) Seine Maritime' +#13+
                          '1Ile de France' +#13+
                          '0(75) Paris' +#13+
                          '0(77) Seine et Marne' +#13+
                          '0(78) Yvelines' +#13+
                          '0(91) Essonne' +#13+
                          '0(92) Hauts de Seine' +#13+
                          '0(93) Seine Saint Denis' +#13+
                          '0(94) Val de Marne' +#13+
                          '0(95) Val d''Oise' +#13+
                          '1Languedoc Roussillon' +#13+
                          '0(11) Aude' +#13+
                          '0(30) Gard' +#13+
                          '0(34) Hrault' +#13+
                          '0(48) Lozre' +#13+
                          '0(66) Pyrnes Orientales' +#13+
                          '1Limousin' +#13+
                          '0(19) Corrze' +#13+
                          '0(23) Creuse' +#13+
                          '0(87) Haute Vienne' +#13+
                          '1Lorraine' +#13+
                          '0(54) Meurthe et Moselle' +#13+
                          '0(55) Meuse' +#13+
                          '0(57) Moselle' +#13+
                          '0(88) Vosges' +#13+
                          '1Midi Pyrnes' +#13+
                          '0(09) Arige' +#13+
                          '0(12) Aveyron' +#13+
                          '0(31) Haute Garonne' +#13+
                          '0(32) Gers' +#13+
                          '0(46) Lot' +#13+
                          '0(65) Hautes Pyrnes' +#13+
                          '0(81) Tarn' +#13+
                          '0(82) Tarn et Garonne' +#13+
                          '1Nord Pas de Calais' +#13+
                          '0(59) Nord' +#13+
                          '0(62) Pas de Calais' +#13+
                          '1Pays de la Loire' +#13+
                          '0(44) Loire Atlantique' +#13+
                          '0(49) Maine et Loire' +#13+
                          '0(53) Mayenne' +#13+
                          '0(72) Sarthe' +#13+
                          '0(85) Vende' +#13+
                          '1Picardie' +#13+
                          '0(02) Aisne' +#13+
                          '0(60) Oise' +#13+
                          '0(80) Somme' +#13+
                          '1Poitou Charentes' +#13+
                          '0(16) Charente' +#13+
                          '0(17) Charente Maritime' +#13+
                          '0(79) Deux Svres' +#13+
                          '0(86) Vienne' +#13+
                          '1Provence Alpes Cte d''Azur' +#13+
                          '0(04) Alpes de Haute Provence' +#13+
                          '0(05) Hautes Alpes' +#13+
                          '0(06) Alpes Maritimes' +#13+
                          '0(13) Bouches du Rhne' +#13+
                          '0(83) Var' +#13+
                          '0(84) Vaucluse' +#13+
                          '1Rhne Alpes' +#13+
                          '0(01) Ain' +#13+
                          '0(07) Ardche' +#13+
                          '0(26) Drme' +#13+
                          '0(38) Isre' +#13+
                          '0(42) Loire' +#13+
                          '0(69) Rhne' +#13+
                          '0(73) Savoie' +#13+
                          '0(74) Haute Savoie' +#13+
                          '1Territoires d''Outre Mer' +#13+
                          '0(984) Terres Australes et Antarctiques' +#13+
                          '0(986) Wallis et Futuna' +#13+
                          '0(987) Polynsie Franaise' +#13+
                          '0(988) Nouvelle Caldonie' +#13;
    Combobox1.Style := csOwnerDrawVariable;
    Combobox1.ItemIndex := 0;
    Combobox1.ItemHeight :=17;
    Combobox1.Width := 220;

    Combobox2.Items.Text := '1Alsace' + #13 +
                            '0Bas-Rhin' + #13+
                            '0Haut-Rhin' +#13+
                            '1Aquitaine' +#13+
                            '0Dordogne' +#13+
                            '0Gironde' +#13+
                            '0Landes' +#13+
                            '0Landes' +#13+
                            '0Lot-et-Garonne' +#13+
                            '0Pyrnes-Atlantiques';
    Combobox2.Style := csOwnerDrawVariable;
    Combobox2.ItemIndex := 0;
    Combobox2.ItemHeight :=17;
    Combobox2.Width := 150
end;

procedure TForm1.ComboBox2DrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
var
  Tabul:byte;
begin
  with Combobox2.canvas do
    begin
      FillRect(Rect);
      InflateRect(Rect,-1,-1);
      Brush.Color := claqua+25*Index; // Dgrad de couleurs
      FillRect(Rect);
      if combobox2.Items.Strings[Index][1]='0' then
      begin
        Tabul:=8;
        font.Color:=clred;
      end
      else
        begin
          Tabul:=2;
          Font.style:=[fsBold];
          Font.Size:=Font.Size+1;
        end;
      TextOut(Rect.Left+Tabul,Rect.Top+2,copy(combobox2.Items.Strings[Index],2,length(combobox2.Items.Strings[Index])-1));
    end;
end;
end.

